/*----- Esercizio a01 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.case1;
    INFILE  'M:\corsi\sas_silvia\datasets\case1.txt' FIRSTOBS=3;
    INPUT   codice
            zona            $   :11.
            prezzo
            stanze
            eta
            riscaldamento   $;
RUN;
 
/*----- Esercizio a02 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.case2;
    INFILE  'M:\corsi\sas_silvia\datasets\case2.txt' FIRSTOBS=3;
    INPUT   codice  
            zona            $   :11.
            prezzo          21-23
            stanze          27
            eta             31-32
            riscaldamento   $   35-36;
RUN;
 
/*----- Esercizio a03 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.case3;
    INFILE  'M:\corsi\sas_silvia\datasets\case3.txt' FIRSTOBS=3 TRUNCOVER;
    INPUT   codice  
            zona            $   :11.
            prezzo          21-23
            stanze          27
            eta             31-32
            riscaldamento   $;
RUN;
 
/*----- Esercizio a04 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA case2;
    INFILE  'M:\corsi\sas_silvia\datasets\case2.txt' FIRSTOBS=3;
    INPUT   codice  
            stanze  27
            prezzo  21-23;
RUN;
 
/*----- Esercizio a05 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.regioni90;
    INFILE  'M:\corsi\sas_silvia\datasets\regioni90.txt' FIRSTOBS=3;
    INPUT   regione $   1-23
            campeggi
            lettic
            alloggi
            lettia
            other;
RUN;
 
/*----- Esercizio a06 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.regioni87;
    INFILE  'M:\corsi\sas_silvia\datasets\regioni87.txt' FIRSTOBS=4;
    INPUT   regione $   1-23
            campeggi
            lettic
            lettia
            other;
RUN;
 
/*----- Esercizio a07 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.pane;
    INFILE  'M:\corsi\sas_silvia\datasets\pane.txt';
    INPUT   tipo        $   :11.
            codifica
            diff
            problema    $   :9.;
RUN;
 
/*----- Esercizio a08 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.alcol;
    INFILE  'M:\corsi\sas_silvia\datasets\alcol.txt' FIRSTOBS=2;
    INPUT   nome        $   :15.
            spesaalc
            spesatab;
RUN;
 
/*----- Esercizio a09 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.hotdog;
    INFILE  'M:\corsi\sas_silvia\datasets\hotdog.txt' FIRSTOBS=2;
    INPUT   tipo        $
            calorie
            sodio;
RUN;
 
/*----- Esercizio a10 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.proteine;
    INFILE  'M:\corsi\sas_silvia\datasets\proteine.txt' FIRSTOBS=2;
    INPUT   country     $   :14.
            redmeat
            whitemeat
            eggs
            milk
            fish
            cereals
            starch
            nuts
            frveg;
RUN;
 
/*----- Esercizio a11 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.crashtest;
    INFILE  'M:\corsi\sas_silvia\datasets\crashtest.txt' FIRSTOBS=2;
    INPUT   marca       $   :10.
            modello     $   :13.
            carid       $   :23.
            caridyear   $   :26.
            head
            chest
            lleg
            rleg
            dp          $   :9.
            prot        $   :15.
            doors
            annop
            wt
            size        $;
RUN;
 
/*----- Esercizio a12 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.prezzicase;
    INFILE  'M:\corsi\sas_silvia\datasets\prezzi case.txt' FIRSTOBS=3;
    INPUT   prezzo
            area
            eta
            servizi
            qtres
            custom
            corner
            costo;
RUN;
 
/*----- Esercizio a13 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.elezioni87;
    INFILE  'M:\corsi\sas_silvia\datasets\el87.txt' FIRSTOBS=3;
    INPUT               @3  /* salto del numero di riga all'inizio della riga */
            provincia   $   :13.
            etot
            vtot
            dc          73-80
            pci         81-89
            psi         90-98
            llomb       99-107
            lven        108-116
            validi;
RUN;

DATA lib.elezioni92;
    INFILE  'M:\corsi\sas_silvia\datasets\el92.txt' FIRSTOBS=3;
    INPUT               @3  /* salto del numero di riga all'inizio della riga */
            provincia   $   :13.
            elm
            elf
            etot
            vom
            vof
            vtot
            dc          72-80
            pds         81-89
            rif         90-98
            psi         99-107
            llomb       108-116
            validi;
RUN;
 
/*----- Esercizio a14 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.mal_anagrafica;
    INFILE  'M:\corsi\sas_silvia\datasets\malattie-anagrafica.txt' FIRSTOBS=2;
    INPUT   codice
            eta
            peso
            alt
            v4
            sex;
RUN;
 
/*----- Esercizio a15 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

PROC IMPORT OUT=lib.mal_dic
    DATAFILE='M:\corsi\sas_silvia\datasets\malattie-dicotomiche.txt'
    DBMS=TAB REPLACE;
    GETNAMES=YES;
    DATAROW=2; 
RUN;
 
/*----- Esercizio a16 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

PROC IMPORT OUT=lib.letturaT
    DATAFILE= "M:\corsi\sas_silvia\datasets\lettura-T.csv"
    DBMS=DLM REPLACE;
    DELIMITER='3B'x;
    GETNAMES=YES;
    DATAROW=2;
RUN;
 
/*----- Esercizio a17 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

PROC IMPORT OUT=lib.letturaC
    DATAFILE= "M:\corsi\sas_silvia\datasets\lettura-C.csv"
    DBMS=DLM REPLACE;
    DELIMITER='3B'x;
    GETNAMES=YES;
    DATAROW=2;
RUN;
 
/*----- Esercizio a18 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.cervello;
    INFILE  'M:\corsi\sas_silvia\datasets\cervello.txt' FIRSTOBS=2;
    INPUT   Gender  $
            FSIQ
            VIQ
            PIQ
            Wg
            Hg
            MRICount;
RUN; 

/*----- Esercizio a19 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.miliardari;
    INFILE  'M:\corsi\sas_silvia\datasets\miliardari.txt' FIRSTOBS=2 MISSOVER;
    INPUT   wealth
            eta
            region  $;
RUN; 

/*----- Esercizio a20 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.spesa;
    INFILE  'M:\corsi\sas_silvia\datasets\spesa.txt' FIRSTOBS=2;
    INPUT   spesa
            ecab
            met
            grow
            young
            old
            west
            state   $;
RUN;

/*----- Esercizio a21 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

PROC IMPORT OUT=lib.atletica
    DATAFILE='M:\corsi\sas_silvia\datasets\atletica.txt'
    DBMS=TAB REPLACE;
    GETNAMES=NO;
    DATAROW=2; 
RUN;

DATA lib.atletica;
    SET lib.atletica;
    RENAME  VAR1=Country
            VAR2=m100
            VAR3=m200
            VAR4=m400
            VAR5=m800
            VAR6=m1500
            VAR7=K5
            VAR8=K10
            VAR9=Marathon;
RUN;
 
/*----- Esercizio u01 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA regioni90;
    SET lib.regioni90;
    RENAME  campeggi=campeggi90
            lettic=lettic90
            alloggi=alloggi90
            lettia=lettia90
            otherex=otherex90
            other=other90;
RUN;

DATA regioni87;
    SET lib.regioni87;
    RENAME  campeggi=campeggi87
            lettic=lettic87
            lettia=lettia87
            other=other87;
RUN;

PROC SORT DATA=regioni87 OUT=regioni87;
    BY regione;
RUN;

PROC SORT DATA=regioni90 OUT=regioni90;
    BY regione;
RUN;


DATA lib.regioni;
    MERGE   regioni87
            regioni90;
RUN;
 
/*----- Esercizio u02 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

PROC SORT DATA=lib.mal_anagrafica OUT=lib.mal_anagrafica;
    BY codice;
RUN;

PROC SORT DATA=lib.mal_dic OUT=lib.mal_dic;
    BY codice;
RUN;

DATA mal_anagrafica;
    SET lib.mal_anagrafica;
    RENAME v4=v4_a;
RUN;

DATA lib.malattie;
    MERGE   mal_anagrafica
            lib.mal_dic;
    BY codice;
RUN;
 
/*----- Esercizio u03 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.lettura;
    SET lib.letturaC
        lib.letturaT;
    BY Treatment;
RUN;
 
/*----- Esercizio u04 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA elezioni87;
    SET lib.elezioni87;
    RENAME  etot=etot87
            vtot=vtot87
            dc=dc87
            pci=pci87
            psi=psi87
            llomb=llomb87
            lven=lven87
            validi=validi87;
RUN;

DATA elezioni92;
    SET lib.elezioni92;
    RENAME  elm=elm92
            elf=elf92
            etot=etot92
            vom=vom92
            vof=vof92
            vtot=vtot92
            dc=dc92
            pds=pds92
            rif=rif92
            psi=psi92
            llomb=llomb92
            validi=validi92;
RUN;

DATA lib.elezioni;
    MERGE   elezioni87
            elezioni92;

    /* calcolo delle percentuali */
    dc87=dc87/validi87;
    pci87=pci87/validi87;
    psi87=psi87/validi87;
    llomb87=llomb87/validi87;
    lven87=lven87/validi87;

    dc92=dc92/validi92;
    pds92=pds92/validi92;
    rif92=rif92/validi92;
    psi92=psi92/validi92;
    llomb92=llomb92/validi92;
RUN;

PROC SORT DATA=lib.elezioni OUT=lib.elezioni;
    BY Provincia;
RUN;

/*----- Esercizio t01 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA corporeita;
    SET lib.malattie;
    corp=peso/((alt/100)**2);
    IF corp=. THEN
        stato='non classificabile';
    ELSE IF corp<18 THEN
        stato='sotto peso';
    ELSE IF corp<=24 THEN
        stato='normo peso';
    ELSE IF corp<=29 THEN
        stato='sovrappeso';
    ELSE IF corp<=24 THEN
        stato='obesa';
    totmalattie=SUM(OF v1-v16);
RUN;
 
/*----- Esercizio t02 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA cervello;
    SET lib.cervello;
    counter=0;
    IF FSIQ>100 then
        counter=counter+1;
    IF VIQ>100 then
        counter=counter+1;
    IF PIQ>100 then
        counter=counter+1;
RUN;
 
/*----- Esercizio t03 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA cervello;
    SET lib.cervello;
    Wg=Wg*0.61; /* supponendo che 1pound=0.61Kg */
    Hg=Hg*2.6;  /* supponendo che 1inch=2.6cm */
RUN;
 
/*----- Esercizio t04 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA cervello;
    SET lib.cervello;
    MeanIQ=MEAN(FSIQ,VIQ,PIQ);
    giudizio='re del mondo';
    IF MeanIQ<85 THEN
        giudizio='scarso';
    ELSE IF MeanIQ<115 THEN
        giudizio='bravo';
    ELSE
        giudizio='re del mondo';
RUN;
 
/*----- Esercizio t05 --------------------------------------------------------*/
LIBNAME lib 'M:\corsi\sas_silvia\libs';

/* calcolo del rango per FSIQ */
PROC SORT DATA=lib.cervello OUT=cervello;
    BY FSIQ;
RUN;

DATA cervello;
    SET cervello;
    IF FSIQ_rank=. THEN
        FSIQ_rank=0;
    FSIQ_rank=FSIQ_rank+1;
    RETAIN FSIQ_rank;
RUN;

/* calcolo del rango per VIQ */
PROC SORT DATA=cervello OUT=cervello;
    BY VIQ;
RUN;

DATA cervello;
    SET cervello;
    IF VIQ_rank=. THEN
        VIQ_rank=0;
    VIQ_rank=VIQ_rank+1;
    RETAIN VIQ_rank;
RUN;

/* calcolo del rango per PIQ */
PROC SORT DATA=cervello OUT=cervello;
    BY PIQ;
RUN;

DATA cervello;
    SET cervello;
    IF PIQ_rank=. THEN
        PIQ_rank=0;
    PIQ_rank=PIQ_rank+1;
    RETAIN PIQ_rank;
RUN;
 
/*----- EOF ------------------------------------------------------------------*/
