data lib.malveneto1;/*lego i dati e asegnio un nome  al data set*/
infile 'i:\lab2003\malattie veneto.txt' truncover;
input codice 1-4 v1 5-6 v2 7-8 v3   v4 9-10 v5 11-12 v6 13-14 v7 15-16 v8 17-18 v9 19-20 v10 21-22 v11 23-24 v12 25-26 v13 27-28 v14 29-30 v15 31-32 v16 33-34;
label /*do un informazione piu detagliata ai variabili */
codice='codice individuale'
v1='diabete(01)'
v2='ipertensione(02)'
v3='infarto(03)'
v4='angina(04)'v5='malattie cardiache(05)'
v6='bronchite(06)'v7='asma(07)'
v8='allergie(08)'v9='tumore(09)'
v10='ulcera(10)'v11='calcoli(11)'
v12='cirrosi(12)'v13='calcoli renali(13)'
v14='artrosi(14)'v15='osteoporosi(15)'
v16='malattie nervose(16)';
run;
data lib.malveneto;/* lego i dati e gli assegnio un nome   al data set*/
infile 'i:\lab2003\malattie-anagrafica veneto.txt' delimiter='&' DSD firstobs=2;
input codice eta peso altezza va sesso;
label/*do un informazione piu detagliata ai variabili */
codice='un codice individuale' 
eta ='eta in anni compiuti'
peso='peso in kg'
altezza='altezza in cm'
va='abitudine al fumo(1:no,mai;2: in passato,3:si)'
sesso=' sesso(1:maschio,2:femmina)';
run;
data lib.veneto;/* qui facio l'unione dei due dataset in un unico data set chiamato "veneto"*/
merge lib.malveneto  lib.malveneto1;
run;
PROC SORT DATA=lib.veneto /* qui facio ordinare le variabili secondo il codice del paziente */
BY codice;RUN;
/*1 primo esercizio*/
/**********************************************************************************************/
proc freq data=lib.veneto;/* qui calcoliamo le frequenze semplici delle variabili "sesso" e "va" e poi una tabella a doppia entrata per i due variabili sopra descriti*/
tables sesso va sesso*va;/*da dove vediamo che i maschi non fumatori sono dominate dalle  femmine con un percentuale poco piu grande rispeto all numero dei uomini e dono presenti nel campione 1*/run;
/**********************************************************************************************/
proc freq data=lib.veneto;/* invece qui calcoliamo una tabella di doppia entrata per"eta e peso" */
tables eta*peso;/*(Media=36.78359)in anni  del eta e con una (Media=62.57173)in kg*/run;
/**********************************************************************************************/
proc freq data=lib.veneto;
tables altezza*eta;run;/*qui una tabella di doppia enterata delle variabile "altezza e eta"*/
/**********************************************************************************************/
proc freq data=lib.veneto;
tables altezza peso altezza*peso ;run;/*faciamo vedere le frequenze semplici di varabili "altezza e peso una volta da parte e una volta in una taella a doppia entrata*/
/**********************************************************************************************/
proc freq data=lib.veneto;
tables peso*va;run; /* da questa tabella di dopia entrata si vede bene che la  magior parte del nostro campione non sono dipindenti al fummo ovvero sono del tipo uno   */

/*esecizio 7*/
/**********************************************************************************************/
data lib.veneto2(KEEP= sesso eta );/*CREO UNA NUOVA DATA SET CHE L'HO CHIAMO VENETO2 CON LE VARIABILI "SESSO E ETA"*/
set lib.veneto;/* QUI RCHIAMO IL DATA SET CHE DEVO PRELEVARE I DATI  */
if SUM(of v1-v16)& SUM(of v1-v16)>0;/*per avere una condizione che almeno un campione sia malato  ,facio la somma delle 16 malatie e poi meto il fatto che il codice=(la somma delle malatie per un individuo) dovra essere magiore di zero */
run;

/*esercizio 6*/
/**********************************************************************************************/
data lib.eta21(keep= eta altezza sesso);/*ORA creo un dataset delle eta inferiori a 21 anni insieme ad altezze delle campioni */
set lib.veneto;
if eta<21 ;run;
proc reg data=lib.eta21;
model altezza = eta;run;quit;
/*esecizio 5*/
/**********************************************************************************************/
proc corr data=lib.veneto;/*nel caso del intero dataset*/
var eta altezza peso;run;
/**********************************************************************************************/
data lib.eta_21(keep= eta altezza sesso peso);
set lib.veneto;
if eta<21 ;run;
/**********************************************************************************************/
proc corr data=lib.eta_21;/* nel caso del eta inferiore a 21 anni*/
var eta altezza peso;run;
/**********************************************************************************************/
data lib.eta_121(keep= eta altezza sesso peso);/*facio un nuovo data set per l'eta inferiore a 21 anni e per i maschi */
set lib.veneto;
if eta<21 & sesso=1 ;run;
/**********************************************************************************************/
proc corr data=lib.eta_121;/* nel caso del eta inferiore a 21 anni e per i maschi*/
var eta altezza peso;run;
/*****************************************************************************************************************************/
data lib.eta_221(keep= eta altezza sesso peso);/*facio un nuovo data set per l'eta inferiore a 21 anni e per le femmine */
set lib.veneto;                                     
if eta<21 & sesso=2;run;
/**********************************************************************************************/
proc corr data=lib.ETA_221;/* nel caso del eta inferiore a 21 anni e per femmine*/
var eta altezza peso;
run;
/**********************************************************************************************/
/**********************************************************************************************/
/**********************************************************************************************/
/*ESERCIZIO....*/

