LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA lib.ditutto;
	/* inizia a leggere i dati dalla terza riga */
	INFILE  'M:\corsi\sas_silvia\datasets\ditutto.txt' FIRSTOBS=3;
	/* definizione della struttura del file */
	INPUT	codice	1-3 	/*colonne della variabile */
			sesso	$ 4		/* var di un carattere */
			annon	6-7 	/*colonne della variabile */
			titolo	25		/* var di un carattere */
			statoc	9		/* var di un carattere */
					@136	/* salta alla colonna 136  */
			nome	$ :10.	/* mofica del formato della stringa: lenght=10 */
			v1-v4;			/* definisce 4 variabili di tipo uguale */
	LABEL	codice='Codice identificativo'
			annon='Anno di nascita'
			titolo='Titolo di studio'
			statoc='Stato civile'
			nome='Nome dello studente'
			v1='Primo voto'
			v2='Secondo voto'
			v3='Terzo voto'
			v4='Quarto voto';
RUN;
