LIBNAME lib 'M:\corsi\sas_silvia\libs';

/*
-------------------------------------------------------------
NB: cosi' stampa tutte le variabile come le trova:
	PROC PRINT DATA=lib.ditutto NOOBS;
	RUN;
-------------------------------------------------------------
NB: ci sono 2 modalita' dell'uso della parola chiave DATA:
	1) "DATA " --> inizio sezione DATA STEP
	2) "DATA=" --> inizio di un'opzione
-------------------------------------------------------------
- nell'esempio sotto, legge il db file "ditutto.sas7bdat"
- "NOOBS" non stampa le statistiche sui dati
- comando "nuova libreria" sulla barra degli strumenti per
  sostituire il comando LIBNAME
-------------------------------------------------------------
*/
PROC PRINT DATA=ordinato NOOBS;
	VAR	codice nome v1-v4;
	SUM	v1-v4;	/* esegue delle somme parziali */
	BY	sesso;	/* elaborazione dei dati a seconda del sesso
				   NB: funziona solo se i dati sono gia' ordinati
				   secondo quel campo */
RUN;
