LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA dituttoelaborato;
	/* specificazione del dataset da manipolare (usato
	   solo dentro ad un DATA STEP) di tipo ".sas7bdat" */
	SET lib.ditutto;

	/* creazione di nuove variabili */
	anno1900=1900+annon;
	eta=2003-anno1900;

	/* semplice aritmetica */
	puntitot=SUM(OF v1-v4);	/* somma dei voti da v1 a v4 per ogni studente */
	mediavoti=MEAN(v1,v4);	/* media dei voti v1 e v4 per ogni studente */

	/* assegnazione di stringhe */
	giornoesame='mercoled';	/* la prima assegnazione determina la lunghezza
								   della variabile (attenzione agli update successivi) */

	/* modifica del flusso */
	IF v2>7 & v3>6 THEN	DO		/* DO e END racchiudono un blocco di istruzioni */
		giornoesame='luned';
		/* 
		....
		....	altre istruz
		....
		*/
	END

	IF v2>7 & v3<=6 THEN
		giornoesame='marted';

	IF v1<6 | v2<6 | v3<6 | v4<6 THEN
		integrazione=1;
	ELSE
		integrazione=0;

	IF v2<=5 THEN
		v2=6;
RUN;

PROC FREQ;
RUN;
