
LIBNAME lib 'c:\utenti\lab';

         /*************************/
         /* Acquisizione dei dati */
         /*************************/

      /*Acquisizione di pesi1.txt*/
DATA pesi1;
INFILE 'i:\lab2003\pesi1.txt';
INPUT codice  peso1 peso2;
RUN;

PROC PRINT ; RUN;

      /*Acquisizione di pesi2.txt*/
DATA pesi2;
INFILE 'i:\lab2003\pesi2.txt';
INPUT codice  peso1 peso2;
RUN;

PROC PRINT ; RUN;

     /*Creazione del dataset pesi, unione di pesi1 e pesi2*/
DATA pesi;
SET pesi1 pesi2;
RUN;

PROC PRINT ; RUN;


    /*Acquisizione di persone.txt*/
DATA persone;
INFILE 'i:\lab2003\persone.txt';
INPUT codice nome$ cognome$ : 10. sesso$ gruppo$ ;
RUN;


         /*******************************************/
         /* Ordinamento secondo la variabile codice */
         /*******************************************/

PROC SORT DATA=pesi OUT=pesi;
BY codice;
RUN;

PROC SORT DATA=persone OUT=persone;
BY codice;
RUN;

        /***********************************************/
        /* Creazione del dataset permanente unione dei */
        /*  dataset temporanei pesi e persone          */
        /***********************************************/

DATA lib.dieta;
MERGE pesi persone;
BY codice;
RUN;

PROC PRINT;
RUN;
