LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA elezioni87;
	SET	lib.elezioni87;
	RENAME	etot=etot87
			vtot=vtot87
			dc=dc87
			pci=pci87
			psi=psi87
			llomb=llomb87
			lven=lven87
			validi=validi87;
RUN;

DATA elezioni92;
	SET	lib.elezioni92;
	RENAME	elm=elm92
			elf=elf92
			etot=etot92
			vom=vom92
			vof=vof92
			vtot=vtot92
			dc=dc92
			pds=pds92
			rif=rif92
			psi=psi92
			llomb=llomb92
			validi=validi92;
RUN;

DATA lib.elezioni;
	MERGE	elezioni87
			elezioni92;

	/* calcolo delle percentuali */
	dc87=dc87/validi87;
	pci87=pci87/validi87;
	psi87=psi87/validi87;
	llomb87=llomb87/validi87;
	lven87=lven87/validi87;

	dc92=dc92/validi92;
	pds92=pds92/validi92;
	rif92=rif92/validi92;
	psi92=psi92/validi92;
	llomb92=llomb92/validi92;
RUN;

PROC SORT DATA=lib.elezioni OUT=lib.elezioni;
	BY Provincia;
RUN;
