LIBNAME lib 'M:\corsi\sas_silvia\libs';

DATA ospedale;
INFILE 'M:\corsi\sas_silvia\datasets\ospedale.txt' TRUNCOVER;
INPUT tipo @; /* @: lascia in sospeso il processo di acquisizione */
	SELECT;
		WHEN (tipo=1)
		DO;
			/* leggi le var elencate (oppure: INPUT codice nome$ cognome$ eta sesso$;) */			
			INPUT codice 3-6 nome$ 8-18 cognome$ 20-30 eta 32-33 sesso$ 35;
			/* RETAIN: non cancellare i campi elencati quando prosegui con la lettura
			  del record successivo */
			RETAIN codice nome cognome eta sesso;
			/* non scaricare il contenuto del buffer nel dataset esterno */
			DELETE;
		END;

		WHEN (tipo=2)
		DO;
			INPUT tempo 8-10 reparto$ 12-21 medico$ 23-30;
			/* elimina la variabile tipo */
			DROP tipo;
			/* scrittura del buffer come record nel dataset esterno */
			OUTPUT;
		END;
	END;
RUN;

PROC FSVIEW;RUN;
